<template>
  <div>
    <form class="card auth-card" @submit.prevent="submitHandler">
      <div class="card-content">
        <span class="card-title">Домашняя бухгалтерия</span>

        <div class="input-field">
            <input id="email" type="text" v-model.trim="email"
             :class="{invalid: (v$.email.$dirty && !v$.email.required) || (v$.email.$dirty && !v$.email.email) }" />
              <label for="email">Email <span class="required">*</span> </label>
              <!-- <small class="helper-text invalid"
              v-if="v$.email.$dirty && !v$.email.required">
              Polya email pustoy
              </small>
              <small class="helper-text invalid"
              v-else-if="v$.email.$dirty && !v$.email.email">
              Email noto'g'ri
              </small> -->

            <small class="helper-text invalid" v-for="(error, index) of v$.email.$errors" :key="index">
              {{ error.$property }} {{error.$message}}
            </small>
           
        </div>
        <div class="input-field">
          <input id="password" type="password" v-model.trim="password" />
          <label for="password">Пароль</label>
          <small class="helper-text invalid" v-for="(error, index) of v$.password.$errors" :key="index">
              {{ error.$property }} {{error.$message}}
            </small>
        </div>
      </div>
      <div class="card-action">
        <div>
          <button class="btn waves-effect waves-light auth-submit" type="submit">
            Войти
            <i class="material-icons right">send</i>
          </button>
        </div>

        <p class="center">
          Нет аккаунта?
          <router-link to="/register">Зарегистрироваться</router-link>
        </p>
      </div>
    </form>
  </div>
</template>

<script>
import { useVuelidate } from "@vuelidate/core";
import { email, required, minLength } from "@vuelidate/validators";
import messages from '@/utils/messages'
// :class="{invalid: ($v.email.$dirty && !$v.email.required) || $v.email.email}"
export default {
  setup() {
    return { v$: useVuelidate() };
  },
  name: "login",
  data: () => ({
    email: "",
    password: ""
  }),
  mounted(){
    if(messages[this.$route.query.message]){
      this.$message(messages[this.$route.query.message])
    }
  },
  validations() {
    return {
      email: { required, email },
      password: { required, minLength: minLength(6) }
    };
  },
  methods: {
    async submitHandler() {
      this.v$.$touch();
      if (this.v$.$error) return;
      const formdata = {
        email: this.email,
        password: this.password
      };
      try{
        await this.$store.dispatch('login',formdata)
        this.$router.push("/");
      }
      catch(e){
        this.$error(e.message)
      }

      

      
    }
  }
};
</script>